#include <iostream>
#include "globals.h"
#include "ParentProcess.h"
#include "ChildProcess.h"

using namespace std;

int main(void)
{
    int fd[2];  // file descriptors for the pipe

    // Create the pipe.
    pid_t pipe_id = pipe(fd);
    if (pipe_id < 0)
    {
        cerr << "pipe() failed" << endl;
        return pipe_id;
    }

    // Fork a child process.
    pid_t pid = fork();

    ParentProcess parent(fd, pid);
    ChildProcess  child(fd);

    if (pid > 0)
    {
        parent.read_csv();
    }
    else if (pid == 0)
    {
        child.make_table();
    }
    else
    {
        cerr << "fork() failed" << endl;
        return pid;
    }

    return 0;
}
